import SocketclientVue from './socketclient-vue';

let _pnConfig = {};
let _socketClient;

export default {
  /* eslint-disable no-param-reassign */
  install: (Vue, pnConfig) => {
    Vue.mixin({
      created() {
        _socketClient = new SocketclientVue(pnConfig);
      },
    });

    Vue.prototype.$scSubscribe = function (args) {
      _socketClient.subscribe(args);
    };

    Vue.prototype.$scGetMessage = function (channel, callback) {
      _socketClient.addListener('message', function(data) {
        callback(data);
      });
    };
	
	Vue.prototype.$scHistory = function (args) {
      _socketClient.history(args);
    };
	
	Vue.prototype.$scGetHistory = function (channel, callback) {
      _socketClient.subscribe({ channels: channel});
      _socketClient.addListener('history', function(data) {
        callback(data);
      });
    };
  },
};
